//------------------------------------------------------------
//    d_extract
//------------------------------------------------------------
#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iomanip>
#include <math.h>
#include "main.h"

int precision1 = 12;
int wd1;
//------------------------------------------------------------
//    main
//------------------------------------------------------------
int main(int argc, char *argv[])
{
	std::string ss1;
	if((argc>=3)&&(!strcmp(argv[1], "-p"))){
		ss1 = argv[2];
		bool b1 = String_To_Int(ss1, precision1);
		if(!b1) exit(2);
	}
	wd1 = precision1 + 8;
	int gee1, gee2;
	Data_Reduce *dr1 = new Data_Reduce;
	if(read(dr1)!=0){
		delete dr1;
		exit(2);
	}
	if(reduce(dr1)!=0){
		delete dr1;
		exit(2);
	}
	delete dr1;
	return(0);
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
int read(Data_Reduce* data_reduce_1)
{
	int i1 = 0, pos0, pos1, mode1, cnt1, cnt2, n2, r1;
	int pns[1024];
	double c1;
	bool b1;
	std::string str1, str2;
	
	std::cout << "filename:";
	getline(std::cin, data_reduce_1->ifname);
	data_reduce_1->inp1.open(data_reduce_1->ifname.c_str());
	if(!(data_reduce_1->inp1)){
		std::cout << "file cannot open\n";
		return(-1);
	}
	std::cout << "reduce mode {1:SKIP, 2:AVERAGE, 3:CRITERIA}:";
	getline(std::cin, str1);
	b1 = String_To_Int(str1, mode1);
	if(b1==false){
		std::cout << "error\n";
		return(-1);
	}
	switch(mode1){
		case 1:
			data_reduce_1->rm1 = SKIP;
			break;
		case 2:
			data_reduce_1->rm1 = AVERAGE;
			break;
		case 3:
			data_reduce_1->rm1 = CRITERIA;
			break;
		
	}
	std::cout << "rows:";
	getline(std::cin, str1);
	cnt1 = splitstr(str1);
	data_reduce_1->rows_size = cnt1;
	data_reduce_1->rows = new int[cnt1];
	if(cnt1 > 1023){
		std::cout << "error\n";
		return -1;
	}
	n2 = find_commas(str1, cnt1+1, pns);
	b1 = true;
	for(i1 = 0; i1 < cnt1; i1++){
		str2 = str1.substr(pns[i1] + 1, pns[i1+1] - pns[i1] - 1);
		b1 &= String_To_Int(str2, data_reduce_1->rows[i1]);
	}
	if(b1==false){
		std::cout << "error\n";
		return(-1);
	}
	if((mode1==1)||(mode1==2)){
		std::cout << "interval:";
		getline(std::cin, str1);
		b1 = String_To_Int(str1, data_reduce_1->intv);
		if(b1==false){
			std::cout << "error\n";
			return (-1);
		}
	}else if(mode1==3){
		std::cout << "criterial rows:";
		getline(std::cin, str1);
		cnt2 = splitstr(str1);
		data_reduce_1->cr_size = cnt2;
		data_reduce_1->cr_rows = new int[cnt2];
		n2 = find_commas(str1, cnt2+1, pns);
		b1 = true;
		for(i1 = 0; i1 < cnt2; i1++){
			str2 = str1.substr(pns[i1] + 1, pns[i1+1] - pns[i1] - 1);
			b1 &= String_To_Int(str2, data_reduce_1->cr_rows[i1]);
		}
		if(b1==false){
			std::cout << "error\n";
			return(-1);
		}
		std::cout << "criterias:";
		getline(std::cin, str1);
		cnt2 = splitstr(str1);
		data_reduce_1->cr1 = new double[cnt2];
		n2 = find_commas(str1, cnt2+1, pns);
		b1 = true;
		for(i1 = 0; i1 < cnt2; i1++){
			str2 = str1.substr(pns[i1] + 1, pns[i1+1] - pns[i1] - 1);
			b1 &= String_To_Double(str2, data_reduce_1->cr1[i1]);
		}
		if(b1==false){
		std::cout << "error\n";
			return(-1);
		}
	}
	return 0;
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
int reduce(Data_Reduce* data_reduce_1)
{
	double c2;
	int n0, i1, i2, n1, n2, k1, k2, pos0, pos1, intv1, cnt1;
	int pns[1024], r1;
	bool b1, b2, b3;
	std::string line1, line2, oname, ss;
	
	n0 = data_reduce_1->rows_size;
	double c1[n0], c1_old[n0];
	std::string strs[n0];
	for(i1 = 0; i1 < n0; i1++){
		c1[i1] = 0.0;
		c1_old[i1] = 0.0;
		strs[i1] = "";
	}
	
	
	oname = data_reduce_1->ifname;
	k1 = oname.rfind(".", oname.size());
	oname.insert(k1, "_reduce");
	data_reduce_1->out1.open(oname.c_str());
	
	n1 = 0;
	intv1 = data_reduce_1->intv;
	switch(data_reduce_1->rm1){
		case SKIP:
			while(getline(data_reduce_1->inp1, line1)){
				if((n1+1)%intv1==0){
					cnt1 = splitstr(line1);
					if(cnt1 > 1023){
						std::cout << "error\n";
						return -1;
					}
					n2 = find_commas(line1, cnt1+1, pns);
					pos0 = 0;
					for(i1 = 0; i1 < n0; i1++){
						r1 = data_reduce_1->rows[i1];
						strs[i1] =
							line1.substr(pns[r1] + 1, pns[r1+1] - pns[r1] - 1);
					}
					for(i1 = 0; i1 < n0; i1++){
						data_reduce_1->out1 << strs[i1];
						data_reduce_1->out1 << ",";
					}
					data_reduce_1->out1 << std::endl;
				}
				n1++;
			}
			break;
		case AVERAGE:
			while(getline(data_reduce_1->inp1, line1)){
				cnt1 = splitstr(line1);
				if(cnt1 > 1023){
					std::cout << "error\n";
					return -1;
				}
				n2 = find_commas(line1, cnt1+1, pns);
				for(i1 = 0; i1 < n0; i1++){
					r1 = data_reduce_1->rows[i1];
					strs[i1] =
						line1.substr(pns[r1] + 1, pns[r1+1] - pns[r1] - 1);
					b1 = String_To_Double(strs[i1], c2);
					if(b1==false){
						std::cout << "error\n";
						return -1;
					}
					c1[i1] += c2;
				}
				if((n1+1)%intv1==0){
					for(i1 = 0; i1 < n0; i1++){
						data_reduce_1->out1
							<< std::setw(wd1)
							<< std::setprecision(precision1)
							<< c1[i1] / double(intv1);
						data_reduce_1->out1 << ",";
					}
					data_reduce_1->out1 << std::endl;
					for(i1 = 0; i1 < n0; i1++){
						c1[i1] = 0.0;
					}
				}
				n1++;
			}
			break;
		case CRITERIA:
			while(getline(data_reduce_1->inp1, line1)){
				cnt1 = splitstr(line1);
				if(cnt1 > 1023){
					std::cout << "error\n";
					return -1;
				}
				n2 = find_commas(line1, cnt1+1, pns);
				for(i1 = 0; i1 < n0; i1++){
					r1 = data_reduce_1->rows[i1];
					strs[i1] =
						line1.substr(pns[r1] + 1, pns[r1+1] - pns[r1] - 1);
					b1 = String_To_Double(strs[i1], c1[i1]);
					if(b1==false){
						std::cout << "error\n";
						return -1;
					}
				}
				b2 = false;
				for(i1 = 0; i1 < data_reduce_1->cr_size; i1++){
					r1 = data_reduce_1->cr_rows[i1];
					b3 = fabs(c1_old[r1] - c1[r1]) >=
						data_reduce_1->cr1[i1];
					if(b3) c1_old[r1] = c1[r1];
					b2 |= b3;
				}
				if(b2==true){
					for(i1 = 0; i1 < n0; i1++){
						data_reduce_1->out1
							<< std::setw(wd1)
							<< std::setprecision(precision1)
							<< c1[i1];
						data_reduce_1->out1 << ",";
					}
					data_reduce_1->out1 << std::endl;
				}
				n1++;
			}
			break;
	}
	return 0;
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
void erase_white_space(std::string &st1)
{
	std::string::size_type n1;
	n1 = st1.find(" ", 0);
	while( n1!=std::string::npos ){
		st1.erase(n1, 1);
		n1 = st1.find(" ", n1);
	}
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
void str_replace(std::string &st1, std::string st2, std::string st3)
{
	unsigned int sz2, sz3, i1;
	sz2 = st2.size();
	sz3 = st3.size();
	std::string::size_type n1;
	n1 = st1.find(st2, 0);
	while( n1!=std::string::npos ){
		st1.erase(n1, sz2);
		st1.insert(n1, st3);
		n1 = st1.find(st2, (n1+sz3+1));
	}
}

int splitstr(std::string &string1){
	using namespace std;
	int i1, rawall, p1, p2;
	string str0, sgg0, sgg1;
	
	sgg0 = string1;
	
	p1 = sgg0.find("-", 0);
	while(p1!=std::string::npos){
		p2 = p1 + 1;
		while(sgg0[p2]==' '){
			sgg0.erase(p2, 1);
		}
		p1++;
		p1 = sgg0.find("-", p1);
	}
	
	i1 = 0;
	while( (sgg0.find(" ", i1))!=string::npos ){
		i1 = sgg0.find(" ", i1);
		sgg0[i1] = ',';
		i1++;
	}
	i1 = 0;
	while( (sgg0.find("	", i1))!=string::npos ){
		i1 = sgg0.find("	", i1);
		sgg0[i1] = ',';
		i1++;
	}
	sgg0 = "," + sgg0 + ",";
	i1 = 0;
	while( (sgg0.find(",,", i1))!=string::npos ){
		i1 = sgg0.find(",,", i1);
		sgg0.erase(i1, 1);
	}
	
	string1 = sgg0;
	
	i1 = 0;
	rawall = 0;
	while( (sgg0.find(",", i1+1))!=string::npos ){
		i1 = sgg0.find(",", i1+1);
		rawall++;
	}
	return(rawall);
}

bool bools(int n0, bool *bs)
{
	int i1;
	bool b1;
	b1 = false;
	for(i1 = 0; i1 < n0; i1++){
		b1 |= bs[i1];
	}
	return(b1);
}

int find_commas(std::string str1, int count1, int *ns1)
{
	int i1, p1, pos;
	
	pos = 0;
	for(i1 = 0; i1 < count1; i1++){
		pos = str1.find(",", pos);
		if(pos==std::string::npos) return(-1);
		else ns1[i1] = pos;
		pos++;
	}
	return 1;
}

bool String_To_Int(const std::string zz1, int &n1)
{
	std::istringstream stis0(zz1, std::ios_base::in);
	int i1;
	stis0 >> i1;
	n1 = i1;
	
	return(!(stis0.fail()));
}

bool String_To_Double(const std::string zz1, double &gee1)
{
	std::istringstream stis1(zz1, std::ios_base::in);
	double c1;
	stis1 >> c1;
	gee1 = c1;
	
	return(!(stis1.fail()));
}

